package fr.username404.snowygui.gui.feature

import fr.username404.snowygui.ClickGui
import fr.username404.snowygui.gui.elements.ClickBox
import net.minecraft.network.chat.TranslatableComponent

/**
 * Should be used on classes/objects extending [ButtonImpl]
 */
@Target(AnnotationTarget.CLASS)
@Retention(AnnotationRetention.RUNTIME)
annotation class ButtonInfo(
    val parent: Category,
    val kind: Type = Type.TOGGLE
) {
    /**
     * Excludes a class from button collection
     */
    annotation class Ignored

    companion object {
        internal var lightningFactor: Float = 0.33F
        enum class Type {
            TOGGLE,
            CLICK
        }
    }
}; enum class Category(val translationKey: String, val categoryColor: Int) {
    MISC("snowy.clickbox.misc", Colors.BLUE),
    RISKY("snowy.clickbox.risky", Colors.RED),
    MACROS("snowy.clickbox.macros", Colors.GREEN);
    companion object {
        fun fromBox(box: ClickBox): Category? = values().find {
            box.isCategory(it)
        }
    }
    var box: ClickBox = ClickBox(
        x = 4.0 + (ordinal - ClickGui.clickBoxes.count { category ->
            category.hidden
        }) * 86, y = 4.0,
        name = TranslatableComponent(translationKey),
        color = categoryColor
    ); private set
    constructor(translationKey: String, categoryColor: Colors): this(translationKey, categoryColor.hexValue)
    constructor(box: ClickBox): this(translationKey = box.name.key, categoryColor = box.color) { this.box = box }
    init {
        ClickGui.components.add(box)
    }
}
