package fr.username404.snowygui.fabric

import com.mojang.blaze3d.vertex.PoseStack
import fr.username404.snowygui.EventSnowy
import fr.username404.snowygui.Snowy
import fr.username404.snowygui.gui.feature.ButtonImpl
import fr.username404.snowygui.gui.feature.ButtonInfo
import net.fabricmc.api.ClientModInitializer
import net.fabricmc.fabric.api.client.rendering.v1.HudRenderCallback
import net.fabricmc.fabric.api.client.rendering.v1.HudRenderCallback.EVENT
import org.reflections8.Reflections
import org.reflections8.scanners.SubTypesScanner
import org.reflections8.scanners.TypeAnnotationsScanner
import org.reflections8.util.ClasspathHelper
import org.reflections8.util.ConfigurationBuilder

class FabricInit: Snowy(), ClientModInitializer {
    override fun onInitializeClient() {
        atInit()
        EVENT.register(
            object: HudRenderCallback, EventSnowy {
                override val type: String = "HudRender"
                override fun onHudRender(matrixStack: PoseStack?, tickDelta: Float) = fire(matrixStack)
            }
        )
    }
    init {
        annotatedButtons = Reflections(
            ConfigurationBuilder()
                .setUrls(ClasspathHelper.forPackage(FeaturePackage))
                .setScanners(SubTypesScanner(false), TypeAnnotationsScanner())
                .useParallelExecutor()
        ).getTypesAnnotatedWith(ButtonInfo::class.java).filter { it.isValidForButtonCollection() }.map { it.asSubclass(ButtonImpl::class.java) }.toSet()
    }
}